// $Id: RunRefalCompiler.java 2453 2007-02-23 21:09:41Z yura $

import java.io.*;
import java.lang.ClassLoader;
import org.refal.plus.Expr;
import org.refal.plus.comp.CompilerEnvironment;
import org.refal.plus.comp.Compiler;

public class RunRefalCompiler implements CompilerEnvironment
{

    String moduleName;

    public String getModuleName ()
    {
        return moduleName;
    }

    public Reader getInterfReader (String moduleName)
    {
        InputStream is = ClassLoader.getSystemResourceAsStream(moduleName + ".rfi");
        return is == null ? null : new InputStreamReader(is);
    }

    public Reader getImplemReader ()
    {
        InputStream is = ClassLoader.getSystemResourceAsStream(moduleName + ".rf");
        return is == null ? null : new InputStreamReader(is);
    }

    public void makeClass (String className, byte[] bytes)
    {
        try {
            new FileOutputStream(className + ".class").write(bytes);
        } catch (IOException _) {
            return;
        }
    }

    public RunRefalCompiler (String moduleName)
    {
        this.moduleName = moduleName;
    }

    public static void main (String[] args) throws Exception
    {
        for (int i = 0; i < args.length; i++) {
            System.out.println(args[i]);
            if (args[i].endsWith(".rf"))
                Compiler.CompileModule(new RunRefalCompiler(args[i].substring(0, args[i].length() - 3)));
            else
                Compiler.CompileModule(new RunRefalCompiler(args[i]));
        }
    }
}
